import { Mapper } from './Mapper';
import { DataLoaderManager } from '@pallad/dataloader-manager';
import { ObjectTypeComposer } from 'graphql-compose';
import { ID } from '@pallad/id';
import { AsyncOrSync } from 'ts-essentials';
import { QueryHelper } from './QueryHelper';
import { Command } from 'alpha-command-bus-core';
export declare class EntityHelper<TEntity, TGQLContext extends Mapper.BasicGQLContext<TDataLoaderContext> = any, TCommandBusContext = any, TDataLoaderContext = any> {
    private entityType;
    private mapper;
    private dataLoaderManager;
    constructor(entityType: ObjectTypeComposer<TEntity, TGQLContext>, mapper: Mapper, dataLoaderManager: DataLoaderManager);
    static DEFAULT_ID_EXTRACTOR: EntityHelper.IDExtractor;
    static DEFAULT_RESULT_EXTRACTOR: EntityHelper.ResultExtractor;
    createFindByIdResolver<TResult = any, TKey = ID>(options: EntityHelper.FindByIdResolverOptions<TResult, TKey, TCommandBusContext, TDataLoaderContext>): import("graphql-compose").Resolver<any, TGQLContext, any, any>;
    getFindByIdResolver(): import("graphql-compose").Resolver<any, TGQLContext, any, any>;
    createQueryResolver<TQuery>(options: EntityHelper.QueryResolverOptions<any, TCommandBusContext>): import("graphql-compose").Resolver<any, TGQLContext, any, any>;
    getQueryResolver(): import("graphql-compose").Resolver<any, TGQLContext, any, any>;
}
export declare namespace EntityHelper {
    type IDExtractor<TResult = any, TKey = ID> = (result: TResult) => TKey;
    type ResultExtractor<TResult = any> = (result: any) => TResult[];
    interface FindByIdResolverOptions<TResult = any, TKey = ID, TCommandBusContext = any, TDataLoaderContext = any> {
        dataLoaderName?: string;
        commandFactory: (keys: TKey[], context: TDataLoaderContext) => AsyncOrSync<Command>;
        idExtractor?: IDExtractor<TResult, TKey>;
        resultHandler?: Mapper.ResultHandler;
        resultsExtractor?: ResultExtractor<TResult>;
        context: TCommandBusContext;
    }
    interface QueryResolverOptions<TQuery, TContext> extends QueryHelper.QueryOptions {
        commandFactory: (query: TQuery) => AsyncOrSync<Command>;
        context: TContext;
    }
}
